#AFK Script
#By Einlanzers

import esm
import time

start_afk_time = 600
check_interval = 5 
afktime = {}

def load():
 esm.delayed(check_interval, check_afk)

def check_afk():
  curtime = int(time.time())
  for player in esm.server.getOnlinePlayers():
    name = stripname(player.getDisplayName())
    if name not in afktime:
      afktime[name] = curtime
    if curtime - afktime[name] < start_afk_time:
      update_afk(player, False)
    else:
      update_afk(player, True)
  esm.delayed(check_interval, check_afk)

def player_move(ev):
  player = ev.getPlayer()
  name = stripname(player.getDisplayName())
  afktime[name] = int(time.time())
  update_afk(player, False)
  return True

def player_chat(ev):
  player = ev.getPlayer()
  name = stripname(player.getDisplayName())
  message = ev.getMessage()
  curtime = int(time.time())
  afktime[name] = curtime
  update_afk(player, False)
  if message != "afk":
    return True
  for tplayer in esm.server.getOnlinePlayers():
    tname = stripname(tplayer.getDisplayName())
    if tname not in afktime:
      afktime[tname] = curtime
    if curtime - afktime[tname] < start_afk_time:
      player.sendMessage(tname + ": Active")
    else:
	  gonetime = curtime - afktime[tname]
	  timef = formattime(gonetime)
      player.sendMessage(tname + ": AFK for " + timef)
  return False

def update_afk(player, isafk):
  curname = player.getDisplayName()
  sname = stripname(curname)
  if isafk:
    if curname == sname:
      player.setDisplayName(sname + "-AFK")
      esm.msg(sname + " is now AFK.")
  else:
    if curname != sname:
      player.setDisplayName(sname)
      esm.msg(sname + " is no longer AFK.")

def stripname(name):
  if len(name) < 5:
    return name
  shname = name[-4:len(name)]
  if shname == "-AFK":
    return name[0:len(name)-4]
  return name

def formattime(seconds):
  output = ""
  years = seconds / 31536000
  if years != 0 or output != "":
    if output != "":
      output += ", "
    output += str(years) + " years"
    seconds -= 31536000*years
  months = seconds / 2628000
  if months != 0 or output != "":
    if output != "":
      output += ", "
    output += str(months) + " months"
    seconds -= 2628000*months
  days = seconds / 86400
  if days != 0 or output != "":
    if output != "":
      output += ", "
    output += str(days) + " days"
    seconds -= 86400*days
  hours = seconds / 3600
  if hours != 0 or output != "":
    if output != "":
      output += ", "
    output += str(hours) + " hours"
    seconds -= 3600*hours
  minutes = seconds / 60
  if minutes != 0 or output != "":
    if output != "":
      output += ", "
    output += str(minutes) + " minutes"
    seconds -= 60*minutes
  if output != "":
    output += ", "
  output += str(seconds) + " seconds"
  return output 
